#include <stdio.h>
//#include <string.h>
#include <assert.h>
//#include <unistd.h>
#include "mdcom.h"
#include "mdcom_config.h"

int main (int argc, char **argv)
{
	int ret;
	mdcom_id_t block_id;
	void *p_block;

	printf("MDCOM fifo test program starts.\n");

	/* DualOS-COM 初期化 */
	printf("["MDCOM_DOMAIN_NAME"] start mdcom_init.\n");
	ret = mdcom_init(0x1, -1);
	assert(ret == 0);
	printf("["MDCOM_DOMAIN_NAME"] end   mdcom_init. ret = %x\n", ret);
	
	/* マスタ処理完了待ち */
	printf("["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_wait.\n");
	ret = mdcom_fifoch_wait(MDCOM_FIFOCH_0, -1);
	assert(ret == 0);
	printf("["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_wait. ret = %x\n", ret);

	/* FIFO からポインタ取得 */
	printf("["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_dequeue.\n");
	ret = mdcom_fifoch_dequeue(MDCOM_FIFOCH_0, &block_id);
	assert(ret == 0);
	printf("["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_dequeue. ret = %d\n", ret);

	/* FIFO ブロック取得 */
	printf("["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_get.\n");
	ret = mdcom_fifoch_get(MDCOM_FIFOCH_0, block_id, &p_block);
	assert(ret == 0);
	printf("["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_get. ret = %d\n", ret);

	/* FIFO ブロックの中身を読む */
	printf("MSG: %s\n", (char *)p_block);

	/* マスタ側へ通知 */
	printf("["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_notify.\n");
	ret = mdcom_fifoch_notify(MDCOM_FIFOCH_0);
	assert(ret == 0);
	printf("["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_notify. ret = %d\n", ret);
	printf("["MDCOM_DOMAIN_NAME"] test completed.\n");

	return 0;
}
