#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "sample1.h"
#include "sil.h"

#include "mdcom.h"
#include "mdcom_config.h"

#define	SMEMCH_ID1	0

void main_task()
{
	int *p_smemch1, *p_smemch2;
	int ret;
	int i;
	
	ret = 0;

	logtask_flush(0);
	syslog(LOG_NOTICE, "MDCOM shmem test program starts.");

	/* DualOS-COM 初期化 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start mdcom_init.");
	do {
		ret = mdcom_init(0x0, -1);
		syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_init. ret = %d", ret);
	} while (ret != MDCOM_SUCCESS);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_init loop.");
	
	/* 共有メモリポインタ取得 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start mdcom_smemch_get.");
	ret = mdcom_smemch_get(SMEMCH_ID1, (void **)(&p_smemch1));
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_smemch_get. ret = %x", ret);

#if 0	
	/* 共有メモリへ書込み */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start shared memory write.");
	for (i = 0; i < 16; i++) {
		p_smemch1[i] = i;
	}
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   shared memory write.");
#endif
	
#if 1
	/* ロック取得 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start trylock.");
	do {
		ret = mdcom_smemch_trylock(SMEMCH_ID1);
	} while (ret == MDCOM_LOCKED);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   trylock.");

	/* 共有メモリ読込み */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start shared memory read.");
	for (i = 0; i < 16; i++) {
		syslog(LOG_NOTICE, "p_smemch1[%2d] = %8x", i, p_smemch1[i]);
	}
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   shared memory read.");

	/* ロック開放 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start unlock.");
	ret = mdcom_smemch_unlock(SMEMCH_ID1);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   unlock. ret = %d", ret);

    syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] test completed.");
#endif
}
