#ifndef MDCOM_CONFIG_H
#define MDCOM_CONFIG_H
#include "mdcom.h"

/* Number of FIFO Channel, Smem Channel, Filter */
#define MDCOM_NUM_FIFOCHS 2
#define MDCOM_NUM_SMEMCHS 1
#define MDCOM_NUM_M2R_FILTERS 0
#define MDCOM_NUM_R2M_FILTERS 1

/* ID */
#define MDCOM_CHANNEL_0 0
#define MDCOM_CHANNEL_1 1
#define MDCOM_SHMEM_1 0
#define MDCOM_FILTER_ID_EVEN 0

/* FIFO CHANNELS */
#define MDCOM_FIFOCH_NUM_BLOCKS {16, 16}
#define MDCOM_FIFOCH_BLOCK_SIZES {16, 16}
#if MDCOM_TYPE_API == MDCOM_TYPE_API_TOPPERS
#define MDCOM_FIFOCH_SEMAPHORES {MDCOM_SEM_FIFOCH_0, MDCOM_SEM_FIFOCH_1}
#endif /* MDCOM_TYPE_API_ == MDCOM_TYPE_API_TOPPERS */
#define MDCOM_FIFOCH_DEFAULT_R2M_FILTERS {NULL_FILTER, NULL_FILTER}
#define MDCOM_FIFOCH_DEFAULT_M2R_FILTERS {NULL_FILTER, NULL_FILTER}

/* SMEM CHANELS */
#define MDCOM_SMEMCH_BUFFER_SIZES {64}

/* FILTERS */
#if MDCOM_TYPE_ROLL == MDCOM_TYPE_ROLL_MASTER
#endif /* MDCOM_TYPE_ROLL == MDCOM_TYPE_ROLL_MASTER */
#if MDCOM_TYPE_ROLL == MDCOM_TYPE_ROLL_REMOTE
extern bool_t filter_even(void *buffer, uint32_t size);
#define MDCOM_FILTERS {filter_even}
#endif /* MDCOM_TYPE_ROLL == MDCOM_TYPE_ROLL_REMOTE */

/* SHARED REGION */
#define MDCOM_SREGION_FIFOCH_OFFSETS {12, 492}
#define MDCOM_SREGION_PENDING_EVENTS 972
#define MDCOM_SREGION_SMEMCH_OFFSETS {988}
#define MDCOM_SREGION_SIZE 1056

#endif /* MDCOM_CONFIG_H */
