set psu_init     [lindex $argv 0]
set load_obj_r5  [lindex $argv 1]
set zynqmp_utils [lindex $argv 2]
set peta_proj    [lindex $argv 3]

connect
after 100

source $zynqmp_utils

targets -set -nocase -filter {name =~"APU*"} -index 1
rst -system
after 3000

targets -set -nocase -filter {name =~"APU*"} -index 1
reset_apu

targets -set -nocase -filter {name =~"RPU*"} -index 1
clear_rpu_reset


#targets -set -filter {level==0} -index 0
#fpga -file ./soc_fpga_top.bit


targets -set -nocase -filter {name =~ "*PSU*"}
mask_write 0xFFCA0038 0x1C0 0x1C0
targets -set -nocase -filter {name =~ "*MicroBlaze PMU*"}
catch {stop}; after 1000
puts stderr "INFO: Downloading ELF file to the target."
dow $peta_proj/pmufw.elf
after 2000
con

#targets -set -nocase -filter {name =~"APU*" } -index 1
#loadhw -hw system.hdf -mem-ranges [list {0x80000000 0xbfffffff} {0x400000000 0x5ffffffff} {0x1000000000 0x7fffffffff}]
#configparams force-mem-access 1

targets -set -nocase -filter {name =~"APU*"} -index 1
source $psu_init
psu_init
after 1000

psu_ps_pl_isolation_removal
after 1000

psu_ps_pl_reset_config
catch {psu_protection}

targets -set -nocase -filter {name =~"*A53*0"} -index 1
rst -processor
dow $peta_proj/zynqmp_fsbl.elf


targets -set -nocase -filter {name =~"*R5*0"} -index 1
rst -processor
dow $load_obj_r5
configparams force-mem-access 0


targets -set -nocase -filter {name =~"*A53*0"} -index 1
puts stderr "INFO: fsbl booting."
con

#targets -set -nocase -filter {name =~ "*A53*#0"}
#dow -data Image 0x00080000
#after 2000

targets -set -nocase -filter {name =~ "*A53*#0"}
dow -data $peta_proj/image.ub 0x10200000
after 2000

#targets -set -nocase -filter {name =~ "*A53*#0"}
#dow -data system.dtb 0x1407f000
#after 2000

targets -set -nocase -filter {name =~ "*A53*#0"} -index 1
puts stderr "INFO: Downloading ELF file to the target."
#dow linux-boot.elf
dow $peta_proj/u-boot.elf
after 2000

targets -set -nocase -filter {name =~ "*A53*#0"} -index 1
puts stderr "INFO: Downloading ELF file to the target."
dow $peta_proj/bl31.elf
after 2000

targets -set -nocase -filter {name =~ "*A53*#0"} -index 1
con

targets -set -nocase -filter {name =~ "*R5*0"} -index 1
con
exit
